{% extends "layout.html" %} {% block title %}Emotion Detection{% endblock %} {%
set custom_color = "16, 160, 0" %} {% block bg_color %}rgba(16, 160, 0, .15){%
endblock %} {% block content %}
<div class="container mt-3">
  <!-- Title -->
  <div class="row justify-content-center mb-5">
    <div class="col text-center">
      <h1 class="mb-0">🎭 Emotion Detection</h1>
    </div>
  </div>

  <!-- Webcam Modal Section -->
  <div class="row justify-content-center">
    <div class="col-lg-6 col-md-6">
      <div class="img rounded-4" style="width: 600px; height: 350px; overflow: hidden">
        <img
          src="../static/bg_image.png"
          style="width: 100%; height: 100%; object-fit: fill"
        />
      </div>
    </div>
    <div class="col-md-6 col-lg-6 mb-4">
        <div class="row">
      <div class="card shadow-custom rounded-4">
        <div class="card-header text-center">Webcam Emotion Detection</div>
        <div class="card-body text-center">
          <button id="webcamBtn" class="btn btn-success rounded-5 w-100">
            <i class="fa-solid fa-camera me-2"></i> Start Webcam Detection
          </button>
          <!-- Modal for Webcam Detection -->
          <div
            id="webcamModal"
            class="modal"
            style="
              display: none;
              position: fixed;
              z-index: 1;
              left: 0;
              top: 0;
              width: 100%;
              height: 100%;
              background-color: rgba(0, 0, 0, 0.4);
              display: flex;
              align-items: center;
              justify-content: center;
            "
          >
            <div
              class="modal-content"
              style="
                background-color: #fefefe;
                margin: auto;
                padding: 20px;
                border: 1px solid #888;
                width: fit-content;
                box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2),
                  0 6px 20px 0 rgba(0, 0, 0, 0.19);
                display: flex;
                flex-direction: column;
                align-items: center;
              "
            >
              <span
                class="close"
                style="
                  color: #aaa;
                  font-size: 28px;
                  font-weight: bold;
                  position: absolute;
                  right: 20px;
                  top: 10px;
                  cursor: pointer;
                "
                >&times;</span
              >
              <h2 class="text-center">Webcam Emotion Detection</h2>
              <img
                id="webcamFeed"
                width="640"
                height="480"
                style="display: none; margin: 0 auto"
              />
              <form action="/stop" method="post">
                <button type="submit" class="btn btn-success mt-3 rounded-5">
                  Stop & Show Emotion
                </button>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
<div class="row mt-3">
      <div class="card shadow-custom rounded-4">
        <div class="card-header text-center">
          Upload Video for Emotion Detection
        </div>
        <div class="card-body">
          <form
            id="uploadForm"
            action="/upload_video"
            method="POST"
            enctype="multipart/form-data"
          >
            <div class="mb-3">
              <label for="videofile" class="form-label"
                >Select Video File</label
              >
              <input
                class="form-control"
                type="file"
                id="videoFile"
                name="file"
                required
              />
            </div>
            <button
              type="submit"
              id="uploadButton"
              class="btn btn-success rounded-5 w-100"
            >
              <i class="fa-solid fa-video me-2"></i> Find Emotion
            </button>
          </form>

          <div class="d-flex justify-content-center mt-3">
            <!-- Loading Button -->
            <button
              id="loadingButton"
              class="btn btn-success w-100 rounded-5"
              type="button"
              style="display: none"
            >
              <span
                class="spinner-border spinner-border-sm me-2"
                role="status"
                aria-hidden="true"
              ></span>
              Processing, please wait...
            </button>
          </div>

          {% if emotion %}
          <div class="alert alert-purple mt-4">
            <strong>Generalized Emotion:</strong> {{ emotion }}
          </div>
          {% endif %}
        </div>
      </div>
    </div>
    </div>
  </div>


<script>
  // Get the modal
  var modal = document.getElementById("webcamModal");

  // Get the button that opens the modal
  var btn = document.getElementById("webcamBtn");

  // Get the <span> element that closes the modal
  var span = document.getElementsByClassName("close")[0];

  // Initialize the webcam feed element
  var webcamFeed = document.getElementById("webcamFeed");

  // Ensure the modal is not shown on page load
  window.onload = function () {
    modal.style.display = "none";
    webcamFeed.src = "";
  };

  // When the user clicks the button, open the modal and start webcam feed
  btn.onclick = function () {
    modal.style.display = "block";
    webcamFeed.style.display = "block";
    webcamFeed.src = "/video_feed"; // Start the webcam feed
  };

  // When the user clicks on <span> (x), close the modal and stop webcam feed
  span.onclick = function () {
    modal.style.display = "none";
    webcamFeed.src = ""; // Stop the webcam feed
  };

  // When the user clicks anywhere outside of the modal, close it and stop webcam feed
  window.onclick = function (event) {
    if (event.target == modal) {
      modal.style.display = "none";
      webcamFeed.src = ""; // Stop the webcam feed
    }
  };

  // Handle form submission for video upload
  document.getElementById("uploadForm").onsubmit = function () {
    // Hide the submit button and show the loading button
    document.getElementById("uploadButton").style.display = "none";
    document.getElementById("loadingButton").style.display = "block";
    document.getElementById("uploadButton").disabled = true; // Disable the submit button to prevent multiple submissions
  };
</script>

{% endblock %}
